<?php
/*
Plugin Name: TAC (Theme Authentication Checker)
Plugin URI: http://builtbackwards.com/projects/tac/
Description: TAC scans all of your theme files for potentially malicious or unwanted code.
Author: builtBackwards
Version: 1.1
Author URI: http://builtbackwards.com/
*/

/*  Copyright 2008  builtBackwards (William Langford and Sam Leavens) - (email : contact@builtbackwards.com)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

// Check the theme
function check_theme($template_files) {
	foreach ($template_files as $tfile)
	{	
		$lines = file("../".$tfile, FILE_IGNORE_NEW_LINES);
		$line_index = 0;
		$is_first = true;
		foreach($lines as $this_line)
		{
			if (stristr ($this_line, "base64"))
			{
				if ($is_first) {
						$the_result .= "<strong>File:</strong> " . $tfile; 
						$is_first = false;
					}
				$the_result .= "<div class=\"tacbad\"><strong>Line " . ($line_index+1) . ":</strong> \"" . trim(htmlspecialchars(substr(stristr($this_line, "base64"), 0, 85))) . "...\"</div>";
			}
			$line_index++;
		}
	} 
	if (!isset($the_result)) {
		$the_result = "<div class=\"tacgood\">Theme Ok!</div>";
	}
	return $the_result;
}

function tac_page() {
	if ( function_exists('add_submenu_page') )
		add_submenu_page('themes.php',__('TAC'), __('TAC'), '10', 'tac.php', 'tac');
	}


function tac_init() {
	add_action('admin_menu', 'tac_page');
}

add_action('init', 'tac_init');

function tac() {
	?>
<div class="wrap">
    <h2>
        <?php _e('TAC (Theme Authentication Checker)'); ?>
    </h2>
    <div class="pinfo">
        TAC checks themes to make sure they don't have any malicious code. For more info please go to the plugin page: <a href="http://builtbackwards.com/projects/tac/">http://builtbackwards.com/projects/tac/</a>
    </div>
    <?php
	
	$themes = get_themes();

	$style = '';
	$theme_names = array_keys($themes);
	natcasesort($theme_names);
	foreach ($theme_names as $theme_name) {
		$template_files = $themes[$theme_name]['Template Files'];
		$template = $themes[$theme_name]['Template'];
		$title = $themes[$theme_name]['Title'];
		$version = $themes[$theme_name]['Version'];
		$author = $themes[$theme_name]['Author'];
		$screenshot = $themes[$theme_name]['Screenshot'];
		$stylesheet_dir = $themes[$theme_name]['Stylesheet Dir'];
		?>
    <div id="tacthemes">
        <?php if ( $screenshot ) : ?>
        <img src="<?php echo get_option('siteurl') . '/' . $stylesheet_dir . '/' . $screenshot; ?>" alt="" />
        <?php endif; 
?>
        <h3>
            <?php echo "$template $version by $author"; ?>
        </h3>
        <?php echo check_theme($template_files); ?>
    </div>
    <?php
	}
	echo '</div>';
}

// CSS to format the list of themes checked
function tac_css() {
echo '
<style type="text/css">
<!--
.tacbad {
    border: 1px solid #000;
    background: #FFC0CB;
    width: 80%;
    margin-left: 140px;
    font-family: "Courier New", Courier, monospace;
    margin-top: 8px;
    padding: 10px;
}

.tacgood {
    width: 90px;
    background: #3fc33f;
    font-size: 120%;
    margin: 10px 10px 10px 140px;
    padding: 10px;
}

.pinfo {
    background: #DCDCDC;
    margin: 5px;
    padding: 5px;
}

#tacthemes {
    width: 100%;
    padding-bottom: 20px;
    border-bottom: 1px solid #ccc;
    margin: 10px;
}

#tacthemes img {
    float: left;
    width: 100px;
    height: 75px;
    border: 1px solid #000;
    margin: 10px 20px 10px 10px;
}
-->
</style>
';
	}

add_action('admin_head', 'tac_css');
?>
